use std::path::PathBuf;

use viperid::{Device, VResult};

use crate::go_builder::GoBuilder;

mod go_builder;

fn main() -> VResult<()> {
    let builder = GoBuilder::new(
        &PathBuf::from("example_project"))?;
    let wasm = builder.build()?;
    let device = Device::new();

    let mut executor = player::Executor::new(device.share(), &wasm)?;

    minifb_host::host(device, || {
        executor.update();
        executor.get_error()?;
        Ok(())
    })?;

    Ok(())
}
